/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.util.logging.Logger;

import jp.co.ntt.lms.installer.common.ConfirmUpdateAction;
import jp.co.ntt.lms.installer.common.ConfirmUpdateValue;
import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerPropertiesUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * Smartforce設定ファイルを書き換えるアクションクラス。
 * @author T.Nishiki
 */
public class SmartforceOverwriteAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(SmartforceOverwriteAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * ConfirmUpdateActionでの入力に基づき判定します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return SelectionLoActionにてSmartforceを選択していて、
	 *          ConfirmUpdateActionにて確認が取れていればfalseを戻します。
	 *          それ以外はtrueを戻します。
	 * @throws InstallerException 判定の元となる情報取得に失敗した場合。
	 * @see ConfirmUpdateAction
	 * @see SelectLoAction
	 */
	public boolean isSkipped(InstallerValues values)
			throws InstallerException {
		LoggerUtil.methodHead(_logger, "isSkipped(InstallerValues)");

		boolean skipped = false;
		try {
			// ユーザの最終確認が取れていること
			ConfirmUpdateValue confirmUpdateValue
				= (ConfirmUpdateValue)values.getActionValue(
					ConfirmUpdateAction.class.getName());
			// LO選択でPerceptionを選択していること
			skipped =
				   (values.getOptionLOSelected(
							SmartforceInputValue.KEY_LO) == false)
				|| (confirmUpdateValue.isConfirm() == false);
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		LoggerUtil.methodTail(_logger, "isSkipped(InstallerValues)", skipped);
		return skipped;
	}

	/**
	 * Smartforce設定ファイルを書き換えます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return nullを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see SmartforceInputValue 書換項目に対する入力情報
	 * @see SmartforceInputAction 書換項目に対する入力アクション
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {
		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger, "action(InstallerValues)");
		////////////////////////////////////////////////////////////////////////
		// メソッド本体
		try {
			// 開始メッセージ出力
			InstallerUiUtil.outputMessageAsTitle(
				values,	"SmartforceOverwriteAction.head");
			// 書き込みデータ取得
			String keyInputValue = SmartforceInputAction.class.getName();
			SmartforceInputValue inputValue
				= (SmartforceInputValue)values.getActionValue(keyInputValue);
			if (inputValue == null) {
				throw new NullPointerException(
					"No Exist ActionValue[KEY:" + keyInputValue + "]");
			}
			// 書き込み実施
			InstallerPropertiesUtil.overwriteProperties(values, inputValue);
			// 終了メッセージ出力
			InstallerUiUtil.outputMessage(
				values, "SmartforceOverwriteAction.tail", true);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger, "action(InstallerValues)", null);
		return null;
	}
}
